' LnknLogs.BI - Declarations for the Linkin' Logs 
'		linked list manipulation package

CONST FALSE = 0, TRUE = NOT FALSE
CONST nil = 0, unused = -1
CONST MaxList = 256
CONST NodeBlockSize = 512
CONST FindFirst = 1, FindNext = 2
CONST TheKEY = 0, TheRECORD = 1

' Define the user-defined type for the node data type.
TYPE NodeDataType
    fKey	AS NodeKeyType
    fRec	AS NodeRecType
END TYPE

' Define the user-defined type for the list nodes themselves.
TYPE ListNode
    fData	AS NodeDataType
    fLink	AS INTEGER
END TYPE

' Declare the public interfaces to the Linkin' Logs package
DECLARE SUB NewList (ListHandle AS INTEGER)
DECLARE SUB NewNode (NodePtr AS INTEGER)
DECLARE SUB InsertInPlace (ListHandle AS INTEGER, NodePtr AS INTEGER)
DECLARE SUB InsertAfter (ListPtr AS INTEGER, NodePtr AS INTEGER)
DECLARE SUB DeleteAfter (NodePtr AS INTEGER)
DECLARE SUB PushNode (ListHandle AS INTEGER, NodePtr AS INTEGER)
DECLARE SUB PopNode (ListHandle AS INTEGER)
DECLARE SUB Traverse (ListHandle AS INTEGER, NodePtr AS INTEGER, _
           ActionKey AS INTEGER)
DECLARE SUB StoreNodeData (aNodePtr AS INTEGER, NodeData AS NodeDataType)
DECLARE SUB GetNodeData (NodePtr AS INTEGER, NodeData AS NodeDataType)
DECLARE SUB MarkNode (NodePtr AS INTEGER)
DECLARE FUNCTION NextNode% (NodePtr AS INTEGER)
DECLARE FUNCTION PreviousNode% (ListHandle AS INTEGER, NodePtr AS INTEGER)
